<template>
  <a @click="sendAction()"
      :href="getHref"
     v-bind:class="getClassNames"
     v-bind:data-action="this.action"
     v-bind:data-target="this.cible"
     v-bind:data-url="this.url"
     v-bind:data-id="this.ident"
  >

    <i v-bind:class="getIcon"></i> {{  this.text }}
  </a>
</template>

<script>
import $ from "jquery";

export default {
  name: "ButtonItem",
  props :{
    lien:{
      type: String,
      default: 'javascript:void(0);'
    },
    text: {
      type: String,
      default: ''
    },
    icon: {
      type: String,
      default: ''
    },
    classes: {
      type: String,
      default: ''
    },
    ident: {
      type: String,
      default: ''
    },
    cible: {
      type: String,
      default: ''
    },
    action: {
      type: String,
      default: ''
    },
    url: {
      type: String,
      default: ''
    }
  },
  computed: {
    getHref() {
      return `${this.lien}`
    },
    getIcon() {
      return `fas fa-${this.icon}`
    },
    getClassNames() {
      return `${this.classes}`
    }
  },
  methods: {
    async sendAction() {
      const { data } = await this.$http.get(
          this.url
      );
      let $modal = $(data);
      $('body').append($modal);
      $modal.modal('show');
    }
  }
}
</script>

<style scoped>
  .btn {
    width: 100%;
  }
  .white-link, .white-link:hover, .white-link:visited {
    color: #555555;
  }
</style>